package org.fouram.service;

import java.util.Iterator;

import org.fouram.core.base.service.BaseService;
import org.fouram.core.util.JsonNodeUtil;
import org.fouram.entity.SapBank;
import org.springframework.stereotype.Service;

import com.fasterxml.jackson.databind.JsonNode;

@Service
public class SapBankService extends BaseService {

	public void saveSapData() throws Exception {
		delete("SapBankMapper.deleteAll", null);

		String url = "https://api15.sapsf.cn/odata/v2/cust_bank?$format=json&$expand=cust_bankNav";
		JsonNode node = requestService.getForObject(url, getHttpHeaders());
		if (node != null) {
			Iterator<JsonNode> iterator = node.get("d").get("results").elements();
			while (iterator.hasNext()) {
				JsonNode userNode = iterator.next();
				String userId = JsonNodeUtil.getValue(userNode, "externalCode");
				String bank = JsonNodeUtil.getValue(userNode, "cust_bankNav", "label_zh_CN");
				String branch = JsonNodeUtil.getValue(userNode, "cust_branch");
				String number = JsonNodeUtil.getValue(userNode, "cust_number");
				String effectiveStartDate = JsonNodeUtil.getValue(userNode, "effectiveStartDate");
				SapBank entity = SapBank.builder().userId(userId).bank(bank).branch(branch).number(number)
						.effectiveStartDate(effectiveStartDate).build();
				save("SapBankMapper.save", entity);
			}
		}
	}

	public SapBank selectOneByPersonId(String personId) throws Exception {
		return (SapBank) findObject("SapBankMapper.selectOneByPersonId", personId);
	}
}
