package org.fouram.service;

import java.util.Iterator;

import org.fouram.core.base.service.BaseService;
import org.fouram.core.util.JsonNodeUtil;
import org.fouram.entity.SapPerPerson;
import org.springframework.stereotype.Service;

import com.fasterxml.jackson.databind.JsonNode;

@Service
public class SapPersonService extends BaseService {

	public void saveSapData() throws Exception {
		delete("SapPerPersonMapper.deleteAll", null);

		String url = "https://api15.sapsf.cn/odata/v2/PerPerson?$format=json";
		JsonNode node = requestService.getForObject(url, getHttpHeaders());
		if (node != null) {
			Iterator<JsonNode> iterator = node.get("d").get("results").elements();
			while (iterator.hasNext()) {
				JsonNode userNode = iterator.next();
				String personId = JsonNodeUtil.getValue(userNode, "personIdExternal");// 员工号
				String dateOfBirth = JsonNodeUtil.getValue(userNode, "dateOfBirth");// 出生日期
				String placeOfBirth = JsonNodeUtil.getValue(userNode, "placeOfBirth");// 籍贯
				String education = getLabelValue(JsonNodeUtil.getValue(userNode, "customString1"));// 最高学历
				SapPerPerson entity = SapPerPerson.builder().personId(personId).dateOfBirth(dateOfBirth)
						.placeOfBirth(placeOfBirth).education(education).build();
				save("SapPerPersonMapper.save", entity);
			}
		}
	}

}
